%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %{tool}
% file : FFT_tb.m
%
% Description : The following Matlab testbench excercises the Altera FFT Model FFT_model.m
% generated by Altera's FFT Megacore and outputs results to text files.
%
% 2001-2009 Altera Corporation, All Rights Reserved
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Read transform sizes from source text file
fidnps = fopen('FFT_blksize_report.txt','r');
fidinv = fopen('FFT_inverse_report.txt','r');
% Note: FFT_blksize_report.txt is generated when the HDL simulation is run, so if it does
% not exist then flag an error
if fidnps == -1 
  msgbox('Error: FFT_blksize_report does not exist, run the HDL simulation first.', 'FFT_blksize_report.txt missing', 'error');
elseif fidinv == -1 
  msgbox('Error: FFT_inverse_report does not exist, run the HDL simulation first.', 'FFT_inverse_report.txt missing', 'error');
else
  % Read input complex vector, and transform sizes from source text files 
  fidr = fopen('FFT_real_input.txt','r');                                            
  fidi = fopen('FFT_imag_input.txt','r');
  xreali=fscanf(fidr,'%d');                                                      
  ximagi=fscanf(fidi,'%d');
  nps=fscanf(fidnps,'%d');
  inverse=fscanf(fidinv,'%d'); 
  fclose(fidi);                                                                  
  fclose(fidr);   
  fclose(fidnps); 
  % Create input complex row vector from source text files 
  x = xreali' + j*ximagi';
  [y] = FFT_model(x,nps,inverse); 
  fidro = fopen('FFT_real_output_c_model.txt','w');                                  
  fidio = fopen('FFT_imag_output_c_model.txt','w');
    fprintf(fidro,'%d\n',real(y));                                                 
    fprintf(fidio,'%d\n',imag(y));
  fclose(fidro);                                                                 
  fclose(fidio);
end
