library ieee;
use ieee.std_logic_1164.all;

entity sram_controller is
  
  port (
--	signal read       : in  std_logic;
	signal write      : in  std_logic;
	signal address    : in  std_logic_vector(17 downto 0);
	signal readdata   : out std_logic_vector(15 downto 0);
	signal writedata  : in  std_logic_vector(15 downto 0);
	signal SRAM_DQ : inout std_logic_vector(15 downto 0);
	signal SRAM_ADDR : out std_logic_vector(17 downto 0);
	signal byteenable : in std_logic_vector(1 downto 0);
	signal SRAM_UB_N : out std_logic;
	signal SRAM_LB_N : out std_logic;
	signal SRAM_WE_N : out std_logic;
	signal SRAM_CE_N : out std_logic;
	signal SRAM_OE_N : out std_logic;
	signal VGA_DQ : out std_logic_vector(15 downto 0);
	signal VGA_ADDR : in std_logic_vector(17 downto 0)
    );

end sram_controller;

architecture rtl of sram_controller is
begin
  SRAM_DQ <= writedata when write = '1'
             else (others => 'Z');
  readdata <= SRAM_DQ;
  VGA_DQ <= SRAM_DQ;
  SRAM_ADDR <= address when write = '1'
             else VGA_ADDR;
  SRAM_UB_N <= not byteenable(1);
  SRAM_LB_N <= not byteenable(0);
  SRAM_WE_N <= not write;
  SRAM_CE_N <= '0';
  SRAM_OE_N <= write;
end rtl;