LIBRARY ieee;
   USE ieee.std_logic_1164.all;
   USE ieee.std_logic_unsigned.all;

ENTITY AhCompare IS
	PORT (
		clk			: IN  STD_LOGIC;
		addr 			: IN  STD_LOGIC_VECTOR ( 9 DOWNTO 0);
		rst			: IN  STD_LOGIC;
		data_done	: IN  STD_LOGIC;
		wren 			: IN  STD_LOGIC;
		down_slow	: OUT STD_LOGIC;
		up_slow		: OUT STD_LOGIC;
		hold			: OUT STD_LOGIC
	);
END AhCompare;





ARCHITECTURE logic OF AhCompare IS 

--signal paddr	: std_logic_vector ( 9 downto 0);
--signal caddr	: std_logic_vector ( 9 downto 0);
--signal addr1	: std_logic_vector ( 9 downto 0);
--signal addr2	: std_logic_vector ( 9 downto 0);
--signal addr3	: std_logic_vector ( 9 downto 0);
--signal addr4	: std_logic_vector ( 9 downto 0);
--signal addr_buffer	: std_logic_vector ( 9 downto 0);
--signal paddr_temp	: std_logic_vector ( 10 downto 0);
--signal caddr_temp	: std_logic_vector ( 10 downto 0);
--signal flag1	: std_logic;
--signal flag2	: std_logic;
--
--	BEGIN
--	PROCESS(clk, addr, data_done, rst, wren, clk, paddr, caddr, addr1, addr2, addr3, addr4) BEGIN
--		if rising_edge(clk) then
--		if rst = '1' then
--			addr1 <= (others=>'0');
--			addr2 <= (others=>'0');
--			addr3 <= (others=>'0');
--			addr4 <= (others=>'0');
--			flag1 <= '0';
--			flag2 <= '0';
--		elsif wren = '0' and flag1 = '0' then
--			addr4 <= addr_buffer;
--			addr3 <= addr4;
--			addr2 <= addr3;
--			addr1 <= addr2;
--			flag1 <= '1';
--			flag2 <= '0';
--		elsif (data_done = '1') and wren = '1' and flag2 = '0' then
--					addr_buffer <= addr;
--					flag2 <= '1';
--					flag1 <= '0';
--			else
--					addr_buffer <= addr_buffer;
--		end if;
--		end if;
--	end process;
--
--		paddr_temp <= ('0'&addr1)+('0'&addr2);
--		caddr_temp <= ('0'&addr3)+('0'&addr4);
--		paddr <= paddr_temp(9 downto 0);
--		caddr <= caddr_temp(9 downto 0);

signal paddr	: std_logic_vector ( 9 downto 0);
signal caddr	: std_logic_vector ( 9 downto 0);
 
begin
	PROCESS(addr, data_done, rst, wren, clk, paddr, caddr) BEGIN
		if rst = '1' then
			paddr <= (others=>'0');
			caddr <= (others=>'0');
		elsif wren = '0' then
			paddr <= caddr;
		elsif (data_done = '1') and wren = '1' then
					caddr <= addr;
			else
					caddr <= caddr;
		end if;
		
		if caddr <= "0000000011" then
			down_slow <= '0';
			up_slow <= '0';
			hold <= '0';
		elsif caddr > paddr + "0000000001" then
			if paddr = "0000000000" then
				down_slow <= '0';
				up_slow <= '0';
				hold <= '1';
			else
				down_slow <= '0';
				up_slow <= '0';
				hold <= '0';
			end if;	
		elsif caddr > paddr then
			if paddr = "0000000000" then
				down_slow <= '0';
				up_slow <= '0';
				hold <= '1';
			else
				down_slow <= '0';
				up_slow <= '1';
				hold <= '0';
			end if;
		elsif caddr = paddr and paddr /= "0000000000" then
			down_slow <= '0';
			up_slow <= '0';
			hold <= '1';
		elsif caddr = paddr - "0000000001" then
			if caddr = "0000000000" then
				down_slow <= '0';
				up_slow <= '0';
				hold <= '0';
			else
				down_slow <= '1';
				up_slow <= '0';
				hold <= '0';
			end if;
		else
			down_slow <= '0';
			up_slow <= '0';
			hold <= '0';
		end if;
	END PROCESS;
END logic;