library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;


entity holdvalue is
	port(
		clk		 			: in	std_logic;--this clock should be the clock of sampling data.
		reset	 				: in	std_logic;
		bit_in		 		: in	std_logic;
		bit_out	 			: out	std_logic
	);
end entity;


architecture rtl of holdvalue is
	signal  counter: std_logic_vector(23 downto 0);
	type state_type is (s0, s1);
	signal state   : state_type;
	begin
	process (clk, reset)
	begin
		if reset = '1' then
			state <= s0;
			counter <= (others =>'0');
		elsif (rising_edge(clk)) then
			case state is
				when s0=>
					if bit_in = '1' then 
						state <= s1;
						counter <= (others =>'0');
					else 
						state <= s0;
						counter <= (others =>'0');
					end if;
				when s1=>
					if counter = ("100110001001011010000000") then
						state <= s0;
					else
						state <= s1;
						counter <= counter + '1';
					end if;
				end case;
			end if;
		end process;

	process (state)
	begin
		case state is
			when s0 =>
				bit_out <= '0';
			when s1 =>
				bit_out <= '1';
		end case;
	end process;
end rtl;